unit FormApplicationRunner;

(**
 * A sample application to test CmdExecComponent.
 *
 * by Martin Lovell, martin@hunter-lovell.org
 * Freeware
 *)

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QButtons, CmdExecThread, QExtCtrls, QComCtrls;

type
  TFrmApplicationRunner = class(TForm)
    BtnClose: TBitBtn;
    BtnRun: TBitBtn;
    EdtApplication: TEdit;
    BtnBrowse: TBitBtn;
    Label1: TLabel;
    DlgOpen: TOpenDialog;
    ChkXterm: TCheckBox;
    StatusBar1: TStatusBar;
    CmdExecComponent1: TCmdExecComponent;
    procedure BtnBrowseClick(Sender: TObject);
    procedure BtnRunClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure AppComplete(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  FrmApplicationRunner: TFrmApplicationRunner;

implementation

{$R *.xfm}

procedure TFrmApplicationRunner.AppComplete(Sender: TObject);
begin
  MessageDlg('ApplicationComplete'#13 +
    'Return value = ' + IntToStr(CmdExecComponent1.ReturnValue),
    mtInformation, [mbOk], 0);
  StatusBar1.SimpleText := 'App complete';
end;

procedure TFrmApplicationRunner.BtnBrowseClick(Sender: TObject);
begin
  if DlgOpen.Execute then
    EdtApplication.Text := DlgOpen.FileName;
end;

procedure TFrmApplicationRunner.BtnRunClick(Sender: TObject);
begin
  if EdtApplication.Text <> '' then
  begin
    CmdExecComponent1.Command := EdtApplication.Text;
    if ChkXterm.Checked then
      CmdExecComponent1.Command := 'xterm -e ' + CmdExecComponent1.Command;
    StatusBar1.SimpleText := 'Running: ' + CmdExecComponent1.Command;
    CmdExecComponent1.RunCmd;
  end;
end;

procedure TFrmApplicationRunner.FormResize(Sender: TObject);
begin
  if Height > 400 then Height := 400;
end;

end.
